/* UrlEntry.c generated by valac 0.44.11, the Vala compiler
 * generated from UrlEntry.vala, do not modify */

/*
* Copyright © 2019 Cassidy James Blaede (https://cassidyjames.com)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Cassidy James Blaede <c@ssidyjam.es>
*              Hannes Schulze <haschu0103@gmail.com>
*/

#include <dazzle.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <webkit2/webkit2.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <libsoup/soup.h>
#include <granite.h>
#include <gdk/gdk.h>

#define EPHEMERAL_TYPE_URL_ENTRY (ephemeral_url_entry_get_type ())
#define EPHEMERAL_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntry))
#define EPHEMERAL_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntryClass))
#define EPHEMERAL_IS_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EPHEMERAL_TYPE_URL_ENTRY))
#define EPHEMERAL_IS_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EPHEMERAL_TYPE_URL_ENTRY))
#define EPHEMERAL_URL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntryClass))

typedef struct _EphemeralUrlEntry EphemeralUrlEntry;
typedef struct _EphemeralUrlEntryClass EphemeralUrlEntryClass;
typedef struct _EphemeralUrlEntryPrivate EphemeralUrlEntryPrivate;

#define EPHEMERAL_TYPE_WEB_VIEW (ephemeral_web_view_get_type ())
#define EPHEMERAL_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EPHEMERAL_TYPE_WEB_VIEW, EphemeralWebView))
#define EPHEMERAL_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EPHEMERAL_TYPE_WEB_VIEW, EphemeralWebViewClass))
#define EPHEMERAL_IS_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EPHEMERAL_TYPE_WEB_VIEW))
#define EPHEMERAL_IS_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EPHEMERAL_TYPE_WEB_VIEW))
#define EPHEMERAL_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EPHEMERAL_TYPE_WEB_VIEW, EphemeralWebViewClass))

typedef struct _EphemeralWebView EphemeralWebView;
typedef struct _EphemeralWebViewClass EphemeralWebViewClass;
enum  {
	EPHEMERAL_URL_ENTRY_0_PROPERTY,
	EPHEMERAL_URL_ENTRY_WEB_VIEW_PROPERTY,
	EPHEMERAL_URL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* ephemeral_url_entry_properties[EPHEMERAL_URL_ENTRY_NUM_PROPERTIES];
typedef enum  {
	EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_REMOVED,
	EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ADDED,
	EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ERROR
} EphemeralUrlEntrySuggestionResult;

#define EPHEMERAL_URL_ENTRY_TYPE_SUGGESTION_RESULT (ephemeral_url_entry_suggestion_result_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;

struct _EphemeralUrlEntry {
	DzlSuggestionEntry parent_instance;
	EphemeralUrlEntryPrivate * priv;
};

struct _EphemeralUrlEntryClass {
	DzlSuggestionEntryClass parent_class;
};

struct _EphemeralUrlEntryPrivate {
	GListStore* _list_store;
	gchar* _last_text;
	EphemeralWebView* _web_view;
};

struct _Block13Data {
	int _ref_count_;
	EphemeralUrlEntry* self;
	gchar* clipboard_text;
};

struct _Block14Data {
	int _ref_count_;
	EphemeralUrlEntry* self;
	gchar* tooltip_text;
	gulong changed_event;
};

static gint EphemeralUrlEntry_private_offset;
static gpointer ephemeral_url_entry_parent_class = NULL;
extern GSettings* ephemeral_application_settings;

GType ephemeral_url_entry_get_type (void) G_GNUC_CONST;
GType ephemeral_web_view_get_type (void) G_GNUC_CONST;
GType ephemeral_url_entry_suggestion_result_get_type (void) G_GNUC_CONST;
EphemeralUrlEntry* ephemeral_url_entry_new (EphemeralWebView* _web_view);
EphemeralUrlEntry* ephemeral_url_entry_construct (GType object_type,
                                                  EphemeralWebView* _web_view);
static gboolean ephemeral_url_entry_format_url (EphemeralUrlEntry* self,
                                         const gchar* input,
                                         gchar* * formatted_url);
static void ephemeral_url_entry_filter_suggestions (EphemeralUrlEntry* self,
                                             const gchar* search,
                                             gboolean is_empty);
static GListStore* ephemeral_url_entry_get_list_store (EphemeralUrlEntry* self);
static void _vala_array_add1 (DzlSuggestion** * array,
                       int* length,
                       int* size,
                       DzlSuggestion* value);
EphemeralUrlEntrySuggestionResult ephemeral_url_entry_toggle_suggestion (EphemeralUrlEntry* self,
                                                                         SoupURI* uri);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
static void ephemeral_url_entry_reload_suggestions (EphemeralUrlEntry* self,
                                             gchar** favorites,
                                             gint favorites_length1);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void ephemeral_url_entry_set_secondary_icon (EphemeralUrlEntry* self);
static void ephemeral_url_entry_load_suggestion (EphemeralUrlEntry* self,
                                          const gchar* domain,
                                          const gchar* name,
                                          const gchar* reason,
                                          const gchar* icon);
static void ephemeral_url_entry_set_list_store (EphemeralUrlEntry* self,
                                         GListStore* value);
EphemeralWebView* ephemeral_url_entry_get_web_view (EphemeralUrlEntry* self);
static void _vala_SoupURI_free (SoupURI* self);
static void ephemeral_url_entry_real_populate_popup (GtkEntry* base,
                                              GtkMenu* popup);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void __lambda15_ (Block13Data* _data13_);
static void ___lambda15__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static const gchar* ephemeral_url_entry_get_last_text (EphemeralUrlEntry* self);
static void ephemeral_url_entry_set_last_text (EphemeralUrlEntry* self,
                                        const gchar* value);
void ephemeral_url_entry_set_web_view (EphemeralUrlEntry* self,
                                       EphemeralWebView* value);
static GObject * ephemeral_url_entry_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void _ephemeral_url_entry___lambda16_ (Block14Data* _data14_);
static void __ephemeral_url_entry___lambda16__gtk_editable_changed (GtkEditable* _sender,
                                                             gpointer self);
static void _ephemeral_url_entry___lambda17_ (EphemeralUrlEntry* self);
static void __ephemeral_url_entry___lambda17__gtk_editable_changed (GtkEditable* _sender,
                                                             gpointer self);
static void _ephemeral_url_entry___lambda18_ (EphemeralUrlEntry* self);
static void __ephemeral_url_entry___lambda18__dzl_suggestion_entry_activate_suggestion (DzlSuggestionEntry* _sender,
                                                                                 gpointer self);
static void _ephemeral_url_entry___lambda19_ (EphemeralUrlEntry* self);
static void __ephemeral_url_entry___lambda19__dzl_suggestion_entry_suggestion_activated (DzlSuggestionEntry* _sender,
                                                                                  DzlSuggestion* suggestion,
                                                                                  gpointer self);
static void _ephemeral_url_entry___lambda20_ (Block14Data* _data14_,
                                       gint amount);
static void __ephemeral_url_entry___lambda20__dzl_suggestion_entry_move_suggestion (DzlSuggestionEntry* _sender,
                                                                             gint amount,
                                                                             gpointer self);
static gboolean _ephemeral_url_entry___lambda21_ (EphemeralUrlEntry* self,
                                           GdkEventFocus* event);
static gboolean __ephemeral_url_entry___lambda21__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                      GdkEventFocus* event,
                                                                      gpointer self);
static gboolean _ephemeral_url_entry___lambda22_ (EphemeralUrlEntry* self,
                                           GdkEventFocus* event);
static gboolean __ephemeral_url_entry___lambda22__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                       GdkEventFocus* event,
                                                                       gpointer self);
static void _ephemeral_url_entry___lambda23_ (EphemeralUrlEntry* self,
                                       GtkEntryIconPosition icon_pos,
                                       GdkEventButton* event);
static void __ephemeral_url_entry___lambda23__gtk_entry_icon_release (GtkEntry* _sender,
                                                               GtkEntryIconPosition icon_pos,
                                                               GdkEventButton* event,
                                                               gpointer self);
static void _ephemeral_url_entry___lambda24_ (Block14Data* _data14_,
                                       WebKitWebView* source,
                                       WebKitLoadEvent e);
static void __ephemeral_url_entry___lambda24__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                     WebKitLoadEvent load_event,
                                                                     gpointer self);
static void ephemeral_url_entry_finalize (GObject * obj);
static void _vala_ephemeral_url_entry_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_ephemeral_url_entry_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
ephemeral_url_entry_get_instance_private (EphemeralUrlEntry* self)
{
	return G_STRUCT_MEMBER_P (self, EphemeralUrlEntry_private_offset);
}

GType
ephemeral_url_entry_suggestion_result_get_type (void)
{
	static volatile gsize ephemeral_url_entry_suggestion_result_type_id__volatile = 0;
	if (g_once_init_enter (&ephemeral_url_entry_suggestion_result_type_id__volatile)) {
		static const GEnumValue values[] = {{EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_REMOVED, "EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_REMOVED", "removed"}, {EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ADDED, "EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ADDED", "added"}, {EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ERROR, "EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ERROR", "error"}, {0, NULL, NULL}};
		GType ephemeral_url_entry_suggestion_result_type_id;
		ephemeral_url_entry_suggestion_result_type_id = g_enum_register_static ("EphemeralUrlEntrySuggestionResult", values);
		g_once_init_leave (&ephemeral_url_entry_suggestion_result_type_id__volatile, ephemeral_url_entry_suggestion_result_type_id);
	}
	return ephemeral_url_entry_suggestion_result_type_id__volatile;
}

EphemeralUrlEntry*
ephemeral_url_entry_construct (GType object_type,
                               EphemeralWebView* _web_view)
{
	EphemeralUrlEntry * self = NULL;
	g_return_val_if_fail (_web_view != NULL, NULL);
	self = (EphemeralUrlEntry*) g_object_new (object_type, "hexpand", FALSE, "max-width-chars", 100, "web-view", _web_view, "width-request", 100, NULL);
	return self;
}

EphemeralUrlEntry*
ephemeral_url_entry_new (EphemeralWebView* _web_view)
{
	return ephemeral_url_entry_construct (EPHEMERAL_TYPE_URL_ENTRY, _web_view);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
ephemeral_url_entry_format_url (EphemeralUrlEntry* self,
                                const gchar* input,
                                gchar* * formatted_url)
{
	gchar* _vala_formatted_url = NULL;
	gchar* search_engine = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (input != NULL, FALSE);
	_tmp0_ = ephemeral_application_settings;
	_tmp1_ = g_settings_get_string (_tmp0_, "search-engine");
	search_engine = _tmp1_;
	if (!string_contains (input, "://")) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		if (string_contains (input, ".")) {
			_tmp3_ = !string_contains (input, " ");
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			_tmp2_ = TRUE;
		} else {
			_tmp2_ = g_str_has_prefix (input, "localhost");
		}
		if (_tmp2_) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup_printf ("%s://%s", "http", input);
			_g_free0 (_vala_formatted_url);
			_vala_formatted_url = _tmp4_;
			result = TRUE;
			_g_free0 (search_engine);
			if (formatted_url) {
				*formatted_url = _vala_formatted_url;
			} else {
				_g_free0 (_vala_formatted_url);
			}
			return result;
		} else {
			const gchar* _tmp5_;
			gchar* _tmp6_;
			_tmp5_ = search_engine;
			_tmp6_ = g_strdup_printf (_tmp5_, input);
			_g_free0 (_vala_formatted_url);
			_vala_formatted_url = _tmp6_;
			result = FALSE;
			_g_free0 (search_engine);
			if (formatted_url) {
				*formatted_url = _vala_formatted_url;
			} else {
				_g_free0 (_vala_formatted_url);
			}
			return result;
		}
	} else {
		gchar* _tmp7_;
		_tmp7_ = g_strdup (input);
		_g_free0 (_vala_formatted_url);
		_vala_formatted_url = _tmp7_;
		result = TRUE;
		_g_free0 (search_engine);
		if (formatted_url) {
			*formatted_url = _vala_formatted_url;
		} else {
			_g_free0 (_vala_formatted_url);
		}
		return result;
	}
	_g_free0 (search_engine);
	if (formatted_url) {
		*formatted_url = _vala_formatted_url;
	} else {
		_g_free0 (_vala_formatted_url);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_array_add1 (DzlSuggestion** * array,
                  int* length,
                  int* size,
                  DzlSuggestion* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DzlSuggestion*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
ephemeral_url_entry_filter_suggestions (EphemeralUrlEntry* self,
                                        const gchar* search,
                                        gboolean is_empty)
{
	GListStore* filtered_list_store = NULL;
	GListStore* _tmp0_;
	DzlSuggestion* current_suggestion = NULL;
	DzlSuggestion* _tmp1_;
	gchar* formatted_url = NULL;
	gboolean is_url = FALSE;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	DzlSuggestion* _tmp4_;
	const gchar* _tmp5_ = NULL;
	DzlSuggestion* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	DzlSuggestion* _tmp11_;
	GListStore* _tmp12_;
	DzlSuggestion* _tmp13_;
	GListStore* _tmp54_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (search != NULL);
	_tmp0_ = g_list_store_new (dzl_suggestion_get_type ());
	filtered_list_store = _tmp0_;
	_tmp1_ = dzl_suggestion_new ();
	current_suggestion = _tmp1_;
	_tmp3_ = ephemeral_url_entry_format_url (self, search, &_tmp2_);
	_g_free0 (formatted_url);
	formatted_url = _tmp2_;
	is_url = _tmp3_;
	_tmp4_ = current_suggestion;
	dzl_suggestion_set_id (_tmp4_, search);
	if (is_url) {
		_tmp5_ = _ ("Go to \"%s\"");
	} else {
		_tmp5_ = _ ("Search for \"%s\"");
	}
	_tmp6_ = current_suggestion;
	_tmp7_ = g_markup_escape_text (search, (gssize) -1);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strdup_printf (_tmp5_, _tmp8_);
	_tmp10_ = _tmp9_;
	dzl_suggestion_set_title (_tmp6_, _tmp10_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_tmp11_ = current_suggestion;
	dzl_suggestion_set_icon_name (_tmp11_, "system-search-symbolic");
	_tmp12_ = filtered_list_store;
	_tmp13_ = current_suggestion;
	g_list_store_append (_tmp12_, (GObject*) _tmp13_);
	if (!is_empty) {
		DzlSuggestion** secondary_suggestions = NULL;
		DzlSuggestion** _tmp14_;
		gint secondary_suggestions_length1;
		gint _secondary_suggestions_size_;
		DzlSuggestion** _tmp50_;
		gint _tmp50__length1;
		_tmp14_ = g_new0 (DzlSuggestion*, 0 + 1);
		secondary_suggestions = _tmp14_;
		secondary_suggestions_length1 = 0;
		_secondary_suggestions_size_ = secondary_suggestions_length1;
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp15_ = FALSE;
				_tmp15_ = TRUE;
				while (TRUE) {
					GListStore* _tmp17_;
					DzlSuggestion* suggestion = NULL;
					GListStore* _tmp18_;
					GObject* _tmp19_;
					DzlSuggestion* _tmp20_;
					gboolean _tmp21_ = FALSE;
					gchar* _tmp22_;
					gchar* _tmp23_;
					DzlSuggestion* _tmp24_;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					gboolean _tmp27_;
					gboolean _tmp35_ = FALSE;
					gchar* _tmp36_;
					gchar* _tmp37_;
					DzlSuggestion* _tmp38_;
					const gchar* _tmp39_;
					const gchar* _tmp40_;
					gboolean _tmp41_;
					if (!_tmp15_) {
						gint _tmp16_;
						_tmp16_ = i;
						i = _tmp16_ + 1;
					}
					_tmp15_ = FALSE;
					_tmp17_ = self->priv->_list_store;
					if (!(((guint) i) < g_list_model_get_n_items ((GListModel*) _tmp17_))) {
						break;
					}
					_tmp18_ = self->priv->_list_store;
					_tmp19_ = g_list_model_get_item ((GListModel*) _tmp18_, (guint) i);
					_tmp20_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp19_, dzl_suggestion_get_type ()) ? ((DzlSuggestion*) _tmp19_) : NULL;
					if (_tmp20_ == NULL) {
						_g_object_unref0 (_tmp19_);
					}
					suggestion = _tmp20_;
					_tmp22_ = g_strdup_printf ("^%s", search);
					_tmp23_ = _tmp22_;
					_tmp24_ = suggestion;
					_tmp25_ = dzl_suggestion_get_id (_tmp24_);
					_tmp26_ = _tmp25_;
					_tmp27_ = g_regex_match_simple (_tmp23_, _tmp26_, 0, 0);
					_g_free0 (_tmp23_);
					if (_tmp27_) {
						_tmp21_ = TRUE;
					} else {
						gchar* _tmp28_;
						gchar* _tmp29_;
						DzlSuggestion* _tmp30_;
						const gchar* _tmp31_;
						const gchar* _tmp32_;
						_tmp28_ = g_strdup_printf ("^%s", search);
						_tmp29_ = _tmp28_;
						_tmp30_ = suggestion;
						_tmp31_ = dzl_suggestion_get_title (_tmp30_);
						_tmp32_ = _tmp31_;
						_tmp21_ = g_regex_match_simple (_tmp29_, _tmp32_, 0, 0);
						_g_free0 (_tmp29_);
					}
					if (_tmp21_) {
						GListStore* _tmp33_;
						DzlSuggestion* _tmp34_;
						_tmp33_ = filtered_list_store;
						_tmp34_ = suggestion;
						g_list_store_append (_tmp33_, (GObject*) _tmp34_);
					}
					_tmp36_ = g_strdup_printf (".%s", search);
					_tmp37_ = _tmp36_;
					_tmp38_ = suggestion;
					_tmp39_ = dzl_suggestion_get_id (_tmp38_);
					_tmp40_ = _tmp39_;
					_tmp41_ = g_regex_match_simple (_tmp37_, _tmp40_, 0, 0);
					_g_free0 (_tmp37_);
					if (_tmp41_) {
						_tmp35_ = TRUE;
					} else {
						gchar* _tmp42_;
						gchar* _tmp43_;
						DzlSuggestion* _tmp44_;
						const gchar* _tmp45_;
						const gchar* _tmp46_;
						_tmp42_ = g_strdup_printf (".%s", search);
						_tmp43_ = _tmp42_;
						_tmp44_ = suggestion;
						_tmp45_ = dzl_suggestion_get_title (_tmp44_);
						_tmp46_ = _tmp45_;
						_tmp35_ = g_regex_match_simple (_tmp43_, _tmp46_, 0, 0);
						_g_free0 (_tmp43_);
					}
					if (_tmp35_) {
						DzlSuggestion** _tmp47_;
						gint _tmp47__length1;
						DzlSuggestion* _tmp48_;
						DzlSuggestion* _tmp49_;
						_tmp47_ = secondary_suggestions;
						_tmp47__length1 = secondary_suggestions_length1;
						_tmp48_ = suggestion;
						_tmp49_ = _g_object_ref0 (_tmp48_);
						_vala_array_add1 (&secondary_suggestions, &secondary_suggestions_length1, &_secondary_suggestions_size_, _tmp49_);
					}
					_g_object_unref0 (suggestion);
				}
			}
		}
		_tmp50_ = secondary_suggestions;
		_tmp50__length1 = secondary_suggestions_length1;
		{
			DzlSuggestion** suggestion_collection = NULL;
			gint suggestion_collection_length1 = 0;
			gint _suggestion_collection_size_ = 0;
			gint suggestion_it = 0;
			suggestion_collection = _tmp50_;
			suggestion_collection_length1 = _tmp50__length1;
			for (suggestion_it = 0; suggestion_it < suggestion_collection_length1; suggestion_it = suggestion_it + 1) {
				DzlSuggestion* _tmp51_;
				DzlSuggestion* suggestion = NULL;
				_tmp51_ = _g_object_ref0 (suggestion_collection[suggestion_it]);
				suggestion = _tmp51_;
				{
					GListStore* _tmp52_;
					DzlSuggestion* _tmp53_;
					_tmp52_ = filtered_list_store;
					_tmp53_ = suggestion;
					g_list_store_append (_tmp52_, (GObject*) _tmp53_);
					_g_object_unref0 (suggestion);
				}
			}
		}
		secondary_suggestions = (_vala_array_free (secondary_suggestions, secondary_suggestions_length1, (GDestroyNotify) g_object_unref), NULL);
	}
	_tmp54_ = filtered_list_store;
	dzl_suggestion_entry_set_model ((DzlSuggestionEntry*) self, (GListModel*) _tmp54_);
	_g_free0 (formatted_url);
	_g_object_unref0 (current_suggestion);
	_g_object_unref0 (filtered_list_store);
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

EphemeralUrlEntrySuggestionResult
ephemeral_url_entry_toggle_suggestion (EphemeralUrlEntry* self,
                                       SoupURI* uri)
{
	gchar** current_favorites = NULL;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint current_favorites_length1;
	gint _current_favorites_size_;
	EphemeralUrlEntrySuggestionResult suggestion_result = 0;
	EphemeralUrlEntrySuggestionResult result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (uri != NULL, 0);
	_tmp0_ = ephemeral_application_settings;
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "favorite-websites");
	current_favorites = _tmp2_;
	current_favorites_length1 = _vala_array_length (_tmp1_);
	_current_favorites_size_ = current_favorites_length1;
	suggestion_result = EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ERROR;
	if (uri != NULL) {
		gchar* favorite = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		GSettings* _tmp24_;
		gchar** _tmp25_;
		gint _tmp25__length1;
		_tmp3_ = soup_uri_get_host (uri);
		_tmp4_ = g_strdup (_tmp3_);
		favorite = _tmp4_;
		_tmp5_ = favorite;
		_tmp6_ = current_favorites;
		_tmp6__length1 = current_favorites_length1;
		if (_vala_string_array_contains (_tmp6_, _tmp6__length1, _tmp5_)) {
			const gchar* _tmp7_;
			gchar** pruned_favorites = NULL;
			gchar** _tmp8_;
			gint pruned_favorites_length1;
			gint _pruned_favorites_size_;
			gchar** _tmp9_;
			gint _tmp9__length1;
			gchar** _tmp16_;
			gint _tmp16__length1;
			gchar** _tmp17_;
			gint _tmp17__length1;
			gchar** _tmp18_;
			gint _tmp18__length1;
			_tmp7_ = favorite;
			g_debug ("UrlEntry.vala:223: %s is already a favorite, so removing…", _tmp7_);
			_tmp8_ = g_new0 (gchar*, 0 + 1);
			pruned_favorites = _tmp8_;
			pruned_favorites_length1 = 0;
			_pruned_favorites_size_ = pruned_favorites_length1;
			_tmp9_ = current_favorites;
			_tmp9__length1 = current_favorites_length1;
			{
				gchar** existing_favorite_collection = NULL;
				gint existing_favorite_collection_length1 = 0;
				gint _existing_favorite_collection_size_ = 0;
				gint existing_favorite_it = 0;
				existing_favorite_collection = _tmp9_;
				existing_favorite_collection_length1 = _tmp9__length1;
				for (existing_favorite_it = 0; existing_favorite_it < existing_favorite_collection_length1; existing_favorite_it = existing_favorite_it + 1) {
					gchar* _tmp10_;
					gchar* existing_favorite = NULL;
					_tmp10_ = g_strdup (existing_favorite_collection[existing_favorite_it]);
					existing_favorite = _tmp10_;
					{
						const gchar* _tmp11_;
						const gchar* _tmp12_;
						_tmp11_ = existing_favorite;
						_tmp12_ = favorite;
						if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
							gchar** _tmp13_;
							gint _tmp13__length1;
							const gchar* _tmp14_;
							gchar* _tmp15_;
							_tmp13_ = pruned_favorites;
							_tmp13__length1 = pruned_favorites_length1;
							_tmp14_ = existing_favorite;
							_tmp15_ = g_strdup (_tmp14_);
							_vala_array_add2 (&pruned_favorites, &pruned_favorites_length1, &_pruned_favorites_size_, _tmp15_);
						}
						_g_free0 (existing_favorite);
					}
				}
			}
			_tmp16_ = pruned_favorites;
			_tmp16__length1 = pruned_favorites_length1;
			_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup1 (_tmp16_, _tmp16__length1) : ((gpointer) _tmp16_);
			_tmp17__length1 = _tmp16__length1;
			current_favorites = (_vala_array_free (current_favorites, current_favorites_length1, (GDestroyNotify) g_free), NULL);
			current_favorites = _tmp17_;
			current_favorites_length1 = _tmp17__length1;
			_current_favorites_size_ = current_favorites_length1;
			_tmp18_ = current_favorites;
			_tmp18__length1 = current_favorites_length1;
			ephemeral_url_entry_reload_suggestions (self, _tmp18_, (gint) _tmp18__length1);
			suggestion_result = EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_REMOVED;
			pruned_favorites = (_vala_array_free (pruned_favorites, pruned_favorites_length1, (GDestroyNotify) g_free), NULL);
		} else {
			const gchar* _tmp19_;
			gchar** _tmp20_;
			gint _tmp20__length1;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar** _tmp23_;
			gint _tmp23__length1;
			_tmp19_ = favorite;
			g_debug ("UrlEntry.vala:235: %s is not a favorite, so adding…", _tmp19_);
			_tmp20_ = current_favorites;
			_tmp20__length1 = current_favorites_length1;
			_tmp21_ = favorite;
			_tmp22_ = g_strdup (_tmp21_);
			_vala_array_add3 (&current_favorites, &current_favorites_length1, &_current_favorites_size_, _tmp22_);
			_tmp23_ = current_favorites;
			_tmp23__length1 = current_favorites_length1;
			ephemeral_url_entry_reload_suggestions (self, _tmp23_, (gint) _tmp23__length1);
			suggestion_result = EPHEMERAL_URL_ENTRY_SUGGESTION_RESULT_ADDED;
		}
		_tmp24_ = ephemeral_application_settings;
		_tmp25_ = current_favorites;
		_tmp25__length1 = current_favorites_length1;
		g_settings_set_strv (_tmp24_, "favorite-websites", _tmp25_);
		ephemeral_url_entry_set_secondary_icon (self);
		_g_free0 (favorite);
	}
	result = suggestion_result;
	current_favorites = (_vala_array_free (current_favorites, current_favorites_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
ephemeral_url_entry_load_suggestion (EphemeralUrlEntry* self,
                                     const gchar* domain,
                                     const gchar* name,
                                     const gchar* reason,
                                     const gchar* icon)
{
	DzlSuggestion* suggestion = NULL;
	DzlSuggestion* _tmp0_;
	DzlSuggestion* _tmp1_;
	DzlSuggestion* _tmp2_;
	DzlSuggestion* _tmp3_;
	gchar* description = NULL;
	DzlSuggestion* _tmp6_;
	const gchar* _tmp7_;
	GListStore* _tmp8_;
	DzlSuggestion* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (domain != NULL);
	g_debug ("UrlEntry.vala:254: Loading %s into suggestions…", domain);
	_tmp0_ = dzl_suggestion_new ();
	suggestion = _tmp0_;
	_tmp1_ = suggestion;
	dzl_suggestion_set_id (_tmp1_, domain);
	_tmp2_ = suggestion;
	dzl_suggestion_set_title (_tmp2_, domain);
	_tmp3_ = suggestion;
	dzl_suggestion_set_icon_name (_tmp3_, icon);
	if (name != NULL) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup_printf ("%s – %s", name, reason);
		_g_free0 (description);
		description = _tmp4_;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (reason);
		_g_free0 (description);
		description = _tmp5_;
	}
	_tmp6_ = suggestion;
	_tmp7_ = description;
	dzl_suggestion_set_subtitle (_tmp6_, _tmp7_);
	_tmp8_ = self->priv->_list_store;
	_tmp9_ = suggestion;
	g_list_store_append (_tmp8_, (GObject*) _tmp9_);
	_g_free0 (description);
	_g_object_unref0 (suggestion);
}

static void
ephemeral_url_entry_reload_suggestions (EphemeralUrlEntry* self,
                                        gchar** favorites,
                                        gint favorites_length1)
{
	GListStore* _tmp0_;
	GListStore* _tmp2_;
	GListStore* _tmp3_;
	GListStore* _tmp4_;
	GListStore* _tmp5_;
	g_return_if_fail (self != NULL);
	g_debug ("UrlEntry.vala:273: Reloading suggestions…");
	_tmp0_ = self->priv->_list_store;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_list_store_get_type ())) {
		GListStore* _tmp1_;
		_tmp1_ = self->priv->_list_store;
		g_list_store_remove_all (_tmp1_);
	}
	_tmp2_ = g_list_store_new (dzl_suggestion_get_type ());
	_tmp3_ = _tmp2_;
	ephemeral_url_entry_set_list_store (self, _tmp3_);
	_g_object_unref0 (_tmp3_);
	_tmp4_ = g_list_store_new (dzl_suggestion_get_type ());
	_tmp5_ = _tmp4_;
	dzl_suggestion_entry_set_model ((DzlSuggestionEntry*) self, (GListModel*) _tmp5_);
	_g_object_unref0 (_tmp5_);
	{
		gchar** favorite_collection = NULL;
		gint favorite_collection_length1 = 0;
		gint _favorite_collection_size_ = 0;
		gint favorite_it = 0;
		favorite_collection = favorites;
		favorite_collection_length1 = favorites_length1;
		for (favorite_it = 0; favorite_it < favorite_collection_length1; favorite_it = favorite_it + 1) {
			gchar* _tmp6_;
			gchar* favorite = NULL;
			_tmp6_ = g_strdup (favorite_collection[favorite_it]);
			favorite = _tmp6_;
			{
				const gchar* _tmp7_;
				_tmp7_ = favorite;
				ephemeral_url_entry_load_suggestion (self, _tmp7_, NULL, _ ("Favorite website"), "starred-symbolic");
				_g_free0 (favorite);
			}
		}
	}
	ephemeral_url_entry_load_suggestion (self, "247sports.com", "247Sports", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "6pm.com", "6pm", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "aa.com", "American Airlines", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "aarp.org", "AARP", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "abc.go.com", "ABC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "abcnews.go.com", "ABC News", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "abs-cbnnews.com", "ABS-CBN News", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "accuweather.com", "AccuWeather", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "aclu.org", "American Civil Liberties Union", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ae.com", "American Eagle Outfitters", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "airbnb.com", "Airbnb", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "aliexpress.com", "AliExpress", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "allrecipes.com", "Allrecipes", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "amazon.com", "Amazon", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "amazon.co.uk", "Amazon.co.uk", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "americanexpress.com", "American Express", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ancestry.com", "Ancestry", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "androidcentral.com", "Android Central", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "androidpolice.com", "Android Police", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "answers.com", "Answers", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "aol.com", "AOL", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "appcenter.elementary.io", "elementary AppCenter", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "archive.org", "Internet Archive", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "arstechnica.com", "Ars Technica", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "att.com", "AT&amp;T", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "audible.com", "Audible", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "autotrader.com", "Autotrader", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "azlyrics.com", "AZLyrics", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "babycenter.com", "BabyCenter", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "baidu.com", "Baidu", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bankofamerica.com", "Bank of America", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bankrate.com", "Bankrate", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "barclaycardus.com", "Barclays US", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "barnesandnoble.com", "Barnes &amp; Noble", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bbc.com", "BBC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bbc.co.uk", "BBC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bedbathandbeyond.com", "Bed Bath &amp; Beyond", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bestbuy.com", "Best Buy", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "betanews.com", "BetaNews", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bhphotovideo.com", "B&amp;H Photo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "biblegateway.com", "BibleGateway.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bing.com", "Bing", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bizjournals.com", "The Business Journals", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "blogger.com", "Blogger", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "blogspot.com", "Blogspot", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bloomberg.com", "Bloomberg", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bn.com", "Barnes &amp; Noble", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "bodybuilding.com", "Bodybuilding.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "booking.com", "Booking.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "box.com", "Box", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "buffer.com", "Buffer", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "businessinsider.com", "Business Insider", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "buzzfeed.com", "Buzzfeed", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "capitalone360.com", "Capital One Bank", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "capitalone.com", "Capital One", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "careerbuilder.com", "CareerBuilder", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cars.com", "Cars.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cartoonnetwork.com", "Cartoon Network", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cash.app", "Cash App", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cassidyjames.com", "Cassidy James", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cbs.com", "CBS", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cbsnews.com", "CBS News", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cbssports.com", "CBS Sports", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "chase.com", "Chase", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "chicagotribune.com", "Chicago Tribune", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "chron.com", "The Houston Chronicle", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "citibankonline.com", "Banking with Citi", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "citi.com", "Citi", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cloudflare.com", "Cloudflare", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cnbc.com", "CNBC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cnet.com", "CNET", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cnn.com", "CNN", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "comcast.net", "Comcast", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "comenity.net", "Comenity", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "consumerreports.org", "Consumer Reports", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "costco.com", "Costco", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "coupons.com", "Coupons.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cox.net", "Cox", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cracked.com", "Cracked.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "craigslist.org", "Craigslist", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "creditkarma.com", "Credit Karma", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "custhelp.com", "Oracle Service Cloud", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "cvs.com", "CVS", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dailykos.com", "Daily Kos", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dailymotion.com", "Dailymotion", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "danielfore.com", "Daniel Foré", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "deadspin.com", "Deadspin", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dell.com", "Dell", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "delta.com", "Delta Air Lines", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "deviantart.com", "DeviantArt", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dickssportinggoods.com", "DICK'S Sporting Goods", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dictionary.com", "Dictionary.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "digitalocean.com", "DigitalOcean", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "digitaltrends.com", "Digital Trends", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "diply.com", "Diply", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "directv.com", "DIRECTV", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "discovercard.com", "Discover", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "discover.com", "Discover", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "disney.com", "Disney.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "do.co", "DigitalOcean", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "docs.google.com", "Google Docs", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dominos.com", "Domino's", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "draftkings.com", "DraftKings", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dribbble.com", "Dribbble", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "drive.google.com", "Google Drive", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "dropbox.com", "Dropbox", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "drugs.com", "Drugs.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "duckduckgo.com", "DuckDuckGo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "earthlink.net", "EarthLink", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ebates.com", "Ebates", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ebay.com", "eBay", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "edmunds.com", "Edmunds", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "eff.org", "Electronic Frontier Foundation", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ehow.com", "eHow", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "elementary.io", "elementary", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "engadget.com", "Engadget", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "eonline.com", "E! News", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "epicurious.com", "Epicurious", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "espn.go.com", "ESPN", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "etsy.com", "Etsy", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "eventbrite.com", "Eventbrite", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "evernote.com", "Evernote", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "evite.com", "Evite", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ew.com", "Entertainment Weekly", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "expedia.com", "Expedia", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "facebook.com", "Facebook", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fandango.com", "Fandango", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fanduel.com", "FanDuel", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fanfiction.net", "FanFiction", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fast.com", "Fast.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fedex.com", "FedEx", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "feedly.com", "Feedly", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fidelity.com", "Fidelity Investments", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fitbit.com", "Fitbit", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "flickr.com", "Flickr", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "food52.com", "Food52", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "foodnetwork.com", "Food Network", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "fool.com", "The Motley Fool", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "forbes.com", "Forbes", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "forever21.com", "Forever 21", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "frys.com", "Fry's Home Electronics", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gamefaqs.com", "GameFAQs", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gamespot.com", "GameSpot", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gamestop.com", "GameStop", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gap.com", "Gap", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gawker.com", "Gawker", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "genius.com", "Genius", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gettogether.community", "Get Together", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gfycat.com", "Gfycat", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "giphy.com", "Giphy", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "github.com", "GitHub", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gizmodo.com", "Gizmodo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "glassdoor.com", "Glassdoor", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gmail.com", "Gmail", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "gofundme.com", "GoFundMe", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "goodhousekeeping.com", "Good Housekeeping", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "goodreads.com", "Goodreads", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "google.com", "Google", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "greatergood.com", "GreaterGood", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "groupon.com", "Groupon", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "harvard.edu", "Harvard University", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "healthcare.gov", "HealthCare.gov", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hilton.com", "Hilton", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hm.com", "H&amp;M", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "homedepot.com", "The Home Depot", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hootsuite.com", "Hootsuite", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hotels.com", "Hotels.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hotnewhiphop.com", "HotNewHipHop", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "houzz.com", "Houzz", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hp.com", "HP", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "hsn.com", "HSN", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "huffingtonpost.com", "Huffington Post", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "icloud.com", "iCloud", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "iflscience.com", "IFLScience", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ign.com", "IGN", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ikea.com", "IKEA", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "imdb.com", "Internet Movie Database", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "imgur.com", "Imgur", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "indeed.com", "Indeed", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "independent.co.uk", "The Independent", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "indiatimes.com", "Indiatimes", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "indiegogo.com", "Indiegogo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ind.ie", "Indie", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "instagram.com", "Instagram", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "instructables.com", "Instructables", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "intuit.com", "Intuit", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "io9.com", "io9", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "irs.gov", "Internal Revenue Service", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jalopnik.com", "Jalopnik", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jblive.tv", "Jupiter Broadcasting LIVE!", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jcpenny.com", "JCPenny", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jcrew.com", "J.Crew", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jet.com", "Jet.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jezebel.com", "Jezebel", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "joinmastodon.org", "The Mastodon Project", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "jupiterbroadcasting.com", "Jupiter Broadcasting", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "kbb.com", "Kelly Blue Book", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "kickstarter.com", "Kickstarter", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "kinja.com", "Kinja", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "kmart.com", "Kmart", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "kohls.com", "Khol's", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "kotaku.com", "Kotaku", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ksl.com", "KSL.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "landsend.com", "Lands' End", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "latimes.com", "LA Times", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "legacy.com", "Legacy.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "lego.com", "LEGO", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "lifehacker.com", "Lifehacker", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "linkedin.com", "LinkedIn", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "linuxacademy.com", "Linux Academy", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "linuxunplugged.com", "LINUX Unplugged", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "littlethings.com", "LittleThings", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "liveleak.com", "LiveLeak", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "livestrong.com", "Livestrong", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "livingsocial.com", "LivingSocial", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "llbean.com", "L.L.Bean", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "lunduke.com", "Bryan Lunduke", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "lowes.com", "Lowes", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "macys.com", "Macy's", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mailchimp.com", "Mailchimp", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mapquest.com", "MapQuest", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "marketwatch.com", "MarketWatch", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "marriott.com", "Marriott", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "marthastewart.com", "Martha Stewart", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mashable.com", "Mashable", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "match.com", "Match.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mayoclinic.org", "Mayo Clinic", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "medium.com", "Medium", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "meetup.com", "Meetup", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "merriam-webster.com", "Dictionary by Merriam-Webster", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mic.com", "Mic", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "michaels.com", "Michaels", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mint.com", "Mint", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mit.edu", "Massachusetts Institute of Technology", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mlb.com", "MLB", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "monster.com", "Monster Jobs", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "mozilla.org", "Mozilla", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "msnbc.com", "NBC News", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "msn.com", "Microsoft Live", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "myfitnesspal.com", "MyFitnessPal", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nationalgeographic.com", "National Geographic", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "naver.com", "NAVER", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nba.com", "NBA", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nbc.com", "NBC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nbcnews.com", "NBC News", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nbcsports.com", "NBC Sports", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nesn.com", "NESN", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "newegg.com", "Newegg", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nextdoor.com", "Nextdoor", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nhl.com", "National Hockey League", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nih.gov", "National Institutes of Health", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nike.com", "Nike", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "noaa.gov", "National Oceanic and Atmospheric Administration", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nordstrom.com", "Nordstrom", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "npr.org", "NPR", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ny.gov", "New York State", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nypost.com", "New York Post", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "nytimes.com", "New York Times", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "office365.com", "Office 365", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "officedepot.com", "Office Depot &amp; OfficeMax", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "okcupid.com", "OKCupid", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "omgubuntu.co.uk", "OMG! Ubuntu!", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "opentable.com", "OpenTable", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "oracle.com", "Oracle", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "orbitz.com", "Orbitz", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "overstock.com", "Overstock", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pandora.com", "Pandora", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "patch.com", "Patch", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "patheos.com", "Patheos", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "paypal.com", "PayPal", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pbs.org", "Public Broadcasting Service", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pcmag.com", "PCMag.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "people.com", "PEOPLE", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "phoronix.com", "Phoronix", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pinterest.com", "Pinterest", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "playstation.com", "PlayStation", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pnc.com", "PNC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pof.com", "POF", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "pogo.com", "Pogo.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "politico.com", "POLITICO", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "popsugar.com", "POPSUGAR", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "potterybarn.com", "Pottery Barn", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "priceline.com", "Priceline", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "purdue.edu", "Purdue University", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "puri.sm", "Purism", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "qq.com", "QQ.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "qualtrics.com", "Qualtrics", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "quizlet.com", "Quizlet", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "quora.com", "Quora", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "qvc.com", "QVC", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ravelry.com", "Ravelry", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "realsimple.com", "Real Simple", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "realtor.com", "Realtor.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "redbox.com", "Redbox", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "reddit.com", "Reddit", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "redfin.com", "Redfin", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "refactoringui.com", "Refactoring UI", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "reference.com", "Reference.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "refinery29.com", "Refinery29", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "rei.com", "REI", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "retailmenot.com", "RetailMeNot", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "reuters.com", "Reuters", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "roblox.com", "Roblox", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "rollingstone.com", "Rolling Stone", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "rotoworld.com", "Rotoworld", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "rottentomatoes.com", "Rotten Tomatoes", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "salesforce.com", "Salesforce", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "salon.com", "Salon.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "samsclub.com", "Sam's Club", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sbnation.com", "SBNation", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "schwab.com", "Charles Schwab", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sears.com", "Sears", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sephora.com", "Sephora", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sfgate.com", "SFGATE", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sharepoint.com", "SharePoint", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sheets.google.com", "Google Sheets", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "shopify.com", "Shopify", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "shutterfly.com", "Shutterfly", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "si.com", "Sports Illustrated", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "simple.com", "Simple", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "skype.com", "Skype", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "slate.com", "Slate", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "slides.google.com", "Google Slides", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "slideshare.net", "SlideShare", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "slimbook.es", "SLIMBOOK", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "soundcloud.com", "SoundCloud", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sourceforge.net", "SourceForge", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "southwest.com", "Southwest Airlines", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "spectrum.com", "Spectrum", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "speedtest.net", "Speedtest", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "sprint.com", "Sprint", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "squarespace.com", "Squarespace", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "squareup.com", "Square", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "stackoverflow.com", "Stack Overflow", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "stanford.edu", "Stanford University", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "staples.com", "Staples", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "starbucks.com", "Starbucks", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "startpage.com", "Startpage.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "steamcommunity.com", "Steam Community", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "steampowered.com", "Steam", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "stripe.com", "Stripe", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "stubhub.com", "StubHub", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "surveymonkey.com", "SurveyMonkey", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "swagbucks.com", "Swagbucks", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "system76.com", "System76", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "taobao.com", "Taobao", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "target.com", "Target", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tdbank.com", "TD Bank", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "techcrunch.com", "TechCrunch", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "telegraph.co.uk", "The Telegraph", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "theatlantic.com", "The Atlantic", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "thefreedictionary.com", "The Free Dictionary", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "theguardian.com", "The Guardian", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "thekitchn.com", "Kitchn", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "theonion.com", "The Onion", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "theoutline.com", "The Outline", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "theregister.co.uk", "The Register", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "thesaurus.com", "Thesaurus.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "theverge.com", "The Verge", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "thinkgeek.com", "ThinkGeek", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ticketmaster.com", "Ticketmaster", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tickld.com", "tickld.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tigerdirect.com", "TigerDirect.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "timeanddate.com", "timeanddate.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "time.com", "TIME", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "timewarnercable.com", "Spectrum", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "t-mobile.com", "T-Mobile", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tmobile.com", "T-Mobile", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tmz.com", "TMZ", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "today.com", "TODAY", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tomshardware.com", "Tom's Hardware", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "topix.com", "Topix", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tripadvisor.com", "TripAdvisor", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "trulia.com", "Trulia", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tumblr.com", "Tumblr", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "tvguide.com", "TV Guide", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "twitch.tv", "Twitch", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ulta.com", "Ulta Beauty", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "united.com", "United Airlines", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "unsplash.com", "Unsplash", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "ups.com", "UPS", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "urbandictionary.com", "Urban Dictionary", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "urbanoutfitters.com", "Urban Outfitters", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "usaa.com", "USAA", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "usatoday.com", "USA Today", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "usbank.com", "US Bank", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "usmagazine.com", "Us Weekly", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "usnews.com", "US News &amp; World Report", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "usps.com", "USPS", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "valadoc.org", "Valadoc", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "vanguard.com", "Vanguard", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "verizon.com", "Verizon", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "vice.com", "VICE", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "vimeo.com", "Vimeo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "vistaprint.com", "Vistaprint", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "vox.com", "Vox", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "vrbo.com", "VRBO.com", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "walgreens.com", "Walgreens", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "walmart.com", "Walmart", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "washingtonpost.com", "Washington Post", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wayfair.com", "Wayfair", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "weather.com", "Weather", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "weather.gov", "National Weather Service", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "webex.com", "Cisco Webex", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "webmd.com", "WebMD", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "weebly.com", "Weebly", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wellsfargo.com", "Wells Fargo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "whitepages.com", "Whitepages", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wikia.com", "Wikia", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wikihow.com", "wikiHow", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wikimedia.org", "Wikimedia", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wikipedia.org", "Wikipedia", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wired.com", "WIRED", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wix.com", "Wix", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "woot.com", "Woot", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wordpress.com", "Wordpress", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wsj.com", "Wall Street Journal", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "wunderground.com", "Weather Underground", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "xbox.com", "Xbox", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "xfinity.com", "Xfinity", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "xkcd.com", "xkcd", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "yahoo.com", "Yahoo", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "yellowpages.com", "Yellowpages", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "yelp.com", "Yelp", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "youtube.com", "YouTube", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "zappos.com", "Zappos", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "zazzle.com", "Zazzle", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "zendesk.com", "Zendesk", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "zergnet.com", "ZergNet", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "zillow.com", "Zillow", _ ("Popular website"), "web-browser-symbolic");
	ephemeral_url_entry_load_suggestion (self, "zulily.com", "Zulily", _ ("Popular website"), "web-browser-symbolic");
}

static void
_vala_SoupURI_free (SoupURI* self)
{
	g_boxed_free (soup_uri_get_type (), self);
}

static void
ephemeral_url_entry_set_secondary_icon (EphemeralUrlEntry* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp4_ = _tmp3_;
		_tmp0_ = g_strcmp0 (_tmp4_, "") == 0;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		g_object_set ((GtkEntry*) self, "secondary-icon-name", "go-jump-symbolic", NULL);
		g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-text", _ ("Go"), NULL);
		_tmp5_ = g_strdup ("Return");
		_tmp6_ = g_new0 (gchar*, 1 + 1);
		_tmp6_[0] = _tmp5_;
		_tmp7_ = _tmp6_;
		_tmp7__length1 = 1;
		g_object_get ((GtkEntry*) self, "secondary-icon-tooltip-text", &_tmp8_, NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = _tmp9_;
		_tmp11_ = granite_markup_accel_tooltip (_tmp7_, (gint) 1, _tmp10_);
		_tmp12_ = _tmp11_;
		g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-markup", _tmp12_, NULL);
		_g_free0 (_tmp12_);
		_g_free0 (_tmp10_);
		_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
	} else {
		gchar** current_favorites = NULL;
		GSettings* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint current_favorites_length1;
		gint _current_favorites_size_;
		SoupURI* uri = NULL;
		EphemeralWebView* _tmp16_;
		const gchar* _tmp17_;
		SoupURI* _tmp18_;
		SoupURI* _tmp19_;
		_tmp13_ = ephemeral_application_settings;
		_tmp15_ = _tmp14_ = g_settings_get_strv (_tmp13_, "favorite-websites");
		current_favorites = _tmp15_;
		current_favorites_length1 = _vala_array_length (_tmp14_);
		_current_favorites_size_ = current_favorites_length1;
		_tmp16_ = self->priv->_web_view;
		_tmp17_ = webkit_web_view_get_uri ((WebKitWebView*) _tmp16_);
		_tmp18_ = soup_uri_new (_tmp17_);
		uri = _tmp18_;
		_tmp19_ = uri;
		if (_tmp19_ != NULL) {
			gchar* domain = NULL;
			SoupURI* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar** _tmp24_;
			gint _tmp24__length1;
			gchar* _tmp27_;
			gchar** _tmp28_;
			gchar** _tmp29_;
			gint _tmp29__length1;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			_tmp20_ = uri;
			_tmp21_ = soup_uri_get_host (_tmp20_);
			_tmp22_ = g_strdup (_tmp21_);
			domain = _tmp22_;
			_tmp23_ = domain;
			_tmp24_ = current_favorites;
			_tmp24__length1 = current_favorites_length1;
			if (_vala_string_array_contains (_tmp24_, _tmp24__length1, _tmp23_)) {
				const gchar* _tmp25_;
				_tmp25_ = domain;
				g_debug ("UrlEntry.vala:733: %s is a favorite, showing filled star.", _tmp25_);
				g_object_set ((GtkEntry*) self, "secondary-icon-name", "starred", NULL);
				g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-text", _ ("Remove Website from Suggestions"), NULL);
			} else {
				const gchar* _tmp26_;
				_tmp26_ = domain;
				g_debug ("UrlEntry.vala:737: %s is not a favorite, showing empty star.", _tmp26_);
				g_object_set ((GtkEntry*) self, "secondary-icon-name", "non-starred-symbolic", NULL);
				g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-text", _ ("Add Website to Suggestions"), NULL);
			}
			_tmp27_ = g_strdup ("<Ctrl>d");
			_tmp28_ = g_new0 (gchar*, 1 + 1);
			_tmp28_[0] = _tmp27_;
			_tmp29_ = _tmp28_;
			_tmp29__length1 = 1;
			g_object_get ((GtkEntry*) self, "secondary-icon-tooltip-text", &_tmp30_, NULL);
			_tmp31_ = _tmp30_;
			_tmp32_ = _tmp31_;
			_tmp33_ = granite_markup_accel_tooltip (_tmp29_, (gint) 1, _tmp32_);
			_tmp34_ = _tmp33_;
			g_object_set ((GtkEntry*) self, "secondary-icon-tooltip-markup", _tmp34_, NULL);
			_g_free0 (_tmp34_);
			_g_free0 (_tmp32_);
			_tmp29_ = (_vala_array_free (_tmp29_, _tmp29__length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (domain);
		}
		__vala_SoupURI_free0 (uri);
		current_favorites = (_vala_array_free (current_favorites, current_favorites_length1, (GDestroyNotify) g_free), NULL);
	}
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
	g_atomic_int_inc (&_data13_->_ref_count_);
	return _data13_;
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
		EphemeralUrlEntry* self;
		self = _data13_->self;
		_g_free0 (_data13_->clipboard_text);
		_g_object_unref0 (self);
		g_slice_free (Block13Data, _data13_);
	}
}

static void
__lambda15_ (Block13Data* _data13_)
{
	EphemeralUrlEntry* self;
	gchar* url = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	EphemeralWebView* _tmp3_;
	const gchar* _tmp4_;
	EphemeralWebView* _tmp5_;
	self = _data13_->self;
	g_critical ("UrlEntry.vala:765: item.activate.connect: %s", _data13_->clipboard_text);
	_tmp0_ = g_strdup ("");
	url = _tmp0_;
	ephemeral_url_entry_format_url (self, _data13_->clipboard_text, &_tmp1_);
	_g_free0 (url);
	url = _tmp1_;
	_tmp2_ = url;
	g_critical ("UrlEntry.vala:768: %s", _tmp2_);
	_tmp3_ = self->priv->_web_view;
	_tmp4_ = url;
	webkit_web_view_load_uri ((WebKitWebView*) _tmp3_, _tmp4_);
	_tmp5_ = self->priv->_web_view;
	gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
	_g_free0 (url);
}

static void
___lambda15__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
	__lambda15_ (self);
}

static void
ephemeral_url_entry_real_populate_popup (GtkEntry* base,
                                         GtkMenu* popup)
{
	EphemeralUrlEntry * self;
	Block13Data* _data13_;
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	gchar* _tmp2_;
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp3_;
	self = (EphemeralUrlEntry*) base;
	g_return_if_fail (popup != NULL);
	_data13_ = g_slice_new0 (Block13Data);
	_data13_->_ref_count_ = 1;
	_data13_->self = g_object_ref (self);
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
	_tmp2_ = gtk_clipboard_wait_for_text (_tmp1_);
	_data13_->clipboard_text = _tmp2_;
	g_critical ("UrlEntry.vala:755: populate_popupt: %s", _data13_->clipboard_text);
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Paste and _Go");
	g_object_ref_sink (_tmp3_);
	item = _tmp3_;
	gtk_widget_set_sensitive ((GtkWidget*) item, _data13_->clipboard_text != NULL);
	gtk_widget_show ((GtkWidget*) item);
	gtk_menu_shell_insert ((GtkMenuShell*) popup, (GtkWidget*) item, 3);
	g_signal_connect_data (item, "activate", (GCallback) ___lambda15__gtk_menu_item_activate, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
	_g_object_unref0 (item);
	block13_data_unref (_data13_);
	_data13_ = NULL;
}

static GListStore*
ephemeral_url_entry_get_list_store (EphemeralUrlEntry* self)
{
	GListStore* result;
	GListStore* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list_store;
	result = _tmp0_;
	return result;
}

static void
ephemeral_url_entry_set_list_store (EphemeralUrlEntry* self,
                                    GListStore* value)
{
	GListStore* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_list_store);
	self->priv->_list_store = _tmp0_;
}

static const gchar*
ephemeral_url_entry_get_last_text (EphemeralUrlEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_text;
	result = _tmp0_;
	return result;
}

static void
ephemeral_url_entry_set_last_text (EphemeralUrlEntry* self,
                                   const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_last_text);
	self->priv->_last_text = _tmp0_;
}

EphemeralWebView*
ephemeral_url_entry_get_web_view (EphemeralUrlEntry* self)
{
	EphemeralWebView* result;
	EphemeralWebView* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_web_view;
	result = _tmp0_;
	return result;
}

void
ephemeral_url_entry_set_web_view (EphemeralUrlEntry* self,
                                  EphemeralWebView* value)
{
	g_return_if_fail (self != NULL);
	if (ephemeral_url_entry_get_web_view (self) != value) {
		EphemeralWebView* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_web_view);
		self->priv->_web_view = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, ephemeral_url_entry_properties[EPHEMERAL_URL_ENTRY_WEB_VIEW_PROPERTY]);
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
	g_atomic_int_inc (&_data14_->_ref_count_);
	return _data14_;
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
		EphemeralUrlEntry* self;
		self = _data14_->self;
		_g_free0 (_data14_->tooltip_text);
		_g_object_unref0 (self);
		g_slice_free (Block14Data, _data14_);
	}
}

static void
_ephemeral_url_entry___lambda16_ (Block14Data* _data14_)
{
	EphemeralUrlEntry* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data14_->self;
	_tmp0_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp1_ = _tmp0_;
	if (g_strcmp0 (_tmp1_, "") == 0) {
		const gchar* _tmp2_;
		_tmp2_ = _data14_->tooltip_text;
		gtk_entry_set_placeholder_text ((GtkEntry*) self, _tmp2_);
	} else {
		gtk_entry_set_placeholder_text ((GtkEntry*) self, NULL);
	}
}

static void
__ephemeral_url_entry___lambda16__gtk_editable_changed (GtkEditable* _sender,
                                                        gpointer self)
{
	_ephemeral_url_entry___lambda16_ (self);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
_ephemeral_url_entry___lambda17_ (EphemeralUrlEntry* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	_tmp0_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_strip (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp5_ = _tmp4_;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	ephemeral_url_entry_filter_suggestions (self, _tmp3_, !(_tmp7_ >= 2));
	_g_free0 (_tmp3_);
	_tmp8_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp9_ = _tmp8_;
	ephemeral_url_entry_set_last_text (self, _tmp9_);
}

static void
__ephemeral_url_entry___lambda17__gtk_editable_changed (GtkEditable* _sender,
                                                        gpointer self)
{
	_ephemeral_url_entry___lambda17_ ((EphemeralUrlEntry*) self);
}

static void
_ephemeral_url_entry___lambda18_ (EphemeralUrlEntry* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* url = NULL;
	DzlSuggestion* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	EphemeralWebView* _tmp9_;
	const gchar* _tmp10_;
	EphemeralWebView* _tmp11_;
	_tmp1_ = gtk_entry_get_text ((GtkEntry*) self);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "") == 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_ == NULL;
	}
	if (_tmp0_) {
		gdk_beep ();
		return;
	}
	_tmp5_ = dzl_suggestion_entry_get_suggestion ((DzlSuggestionEntry*) self);
	_tmp6_ = dzl_suggestion_get_id (_tmp5_);
	_tmp7_ = _tmp6_;
	ephemeral_url_entry_format_url (self, _tmp7_, &_tmp8_);
	_g_free0 (url);
	url = _tmp8_;
	_tmp9_ = self->priv->_web_view;
	_tmp10_ = url;
	webkit_web_view_load_uri ((WebKitWebView*) _tmp9_, _tmp10_);
	_tmp11_ = self->priv->_web_view;
	gtk_widget_grab_focus ((GtkWidget*) _tmp11_);
	_g_free0 (url);
}

static void
__ephemeral_url_entry___lambda18__dzl_suggestion_entry_activate_suggestion (DzlSuggestionEntry* _sender,
                                                                            gpointer self)
{
	_ephemeral_url_entry___lambda18_ ((EphemeralUrlEntry*) self);
}

static void
_ephemeral_url_entry___lambda19_ (EphemeralUrlEntry* self)
{
	DzlSuggestion* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = dzl_suggestion_entry_get_suggestion ((DzlSuggestionEntry*) self);
	_tmp1_ = dzl_suggestion_get_id (_tmp0_);
	_tmp2_ = _tmp1_;
	gtk_entry_set_text ((GtkEntry*) self, _tmp2_);
}

static void
__ephemeral_url_entry___lambda19__dzl_suggestion_entry_suggestion_activated (DzlSuggestionEntry* _sender,
                                                                             DzlSuggestion* suggestion,
                                                                             gpointer self)
{
	_ephemeral_url_entry___lambda19_ ((EphemeralUrlEntry*) self);
}

static void
_ephemeral_url_entry___lambda20_ (Block14Data* _data14_,
                                  gint amount)
{
	EphemeralUrlEntry* self;
	gint current_index = 0;
	GObject* new_item = NULL;
	GListModel* _tmp12_;
	GObject* _tmp13_;
	GObject* _tmp14_;
	GObject* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	self = _data14_->self;
	current_index = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GListModel* _tmp2_;
				DzlSuggestion* item = NULL;
				GListModel* _tmp3_;
				GObject* _tmp4_;
				DzlSuggestion* _tmp5_;
				DzlSuggestion* _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				DzlSuggestion* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = dzl_suggestion_entry_get_model ((DzlSuggestionEntry*) self);
				if (!(((guint) i) < g_list_model_get_n_items (_tmp2_))) {
					break;
				}
				_tmp3_ = dzl_suggestion_entry_get_model ((DzlSuggestionEntry*) self);
				_tmp4_ = g_list_model_get_item (_tmp3_, (guint) i);
				_tmp5_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, dzl_suggestion_get_type ()) ? ((DzlSuggestion*) _tmp4_) : NULL;
				if (_tmp5_ == NULL) {
					_g_object_unref0 (_tmp4_);
				}
				item = _tmp5_;
				_tmp6_ = item;
				_tmp7_ = dzl_suggestion_get_id (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = dzl_suggestion_entry_get_suggestion ((DzlSuggestionEntry*) self);
				_tmp10_ = dzl_suggestion_get_id (_tmp9_);
				_tmp11_ = _tmp10_;
				if (g_strcmp0 (_tmp8_, _tmp11_) == 0) {
					current_index = i;
					_g_object_unref0 (item);
					break;
				}
				_g_object_unref0 (item);
			}
		}
	}
	_tmp12_ = dzl_suggestion_entry_get_model ((DzlSuggestionEntry*) self);
	_tmp13_ = g_list_model_get_item (_tmp12_, (guint) (current_index + amount));
	new_item = _tmp13_;
	_tmp14_ = new_item;
	if (_tmp14_ == NULL) {
		DzlSuggestion* _tmp15_;
		GObject* _tmp16_;
		_tmp15_ = dzl_suggestion_entry_get_suggestion ((DzlSuggestionEntry*) self);
		_tmp16_ = _g_object_ref0 ((GObject*) _tmp15_);
		_g_object_unref0 (new_item);
		new_item = _tmp16_;
	}
	g_signal_handler_block (self, _data14_->changed_event);
	_tmp17_ = new_item;
	_tmp18_ = dzl_suggestion_get_id (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, dzl_suggestion_get_type ()) ? ((DzlSuggestion*) _tmp17_) : NULL);
	_tmp19_ = _tmp18_;
	gtk_entry_set_text ((GtkEntry*) self, _tmp19_);
	g_signal_handler_unblock (self, _data14_->changed_event);
	gtk_editable_set_position ((GtkEditable*) self, -1);
	_g_object_unref0 (new_item);
}

static void
__ephemeral_url_entry___lambda20__dzl_suggestion_entry_move_suggestion (DzlSuggestionEntry* _sender,
                                                                        gint amount,
                                                                        gpointer self)
{
	_ephemeral_url_entry___lambda20_ (self, amount);
}

static gboolean
_ephemeral_url_entry___lambda21_ (EphemeralUrlEntry* self,
                                  GdkEventFocus* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	ephemeral_url_entry_set_secondary_icon (self);
	result = FALSE;
	return result;
}

static gboolean
__ephemeral_url_entry___lambda21__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                             GdkEventFocus* event,
                                                             gpointer self)
{
	gboolean result;
	result = _ephemeral_url_entry___lambda21_ ((EphemeralUrlEntry*) self, event);
	return result;
}

static gboolean
_ephemeral_url_entry___lambda22_ (EphemeralUrlEntry* self,
                                  GdkEventFocus* event)
{
	gchar* uri = NULL;
	EphemeralWebView* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_web_view;
	_tmp1_ = webkit_web_view_get_uri ((WebKitWebView*) _tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	uri = _tmp2_;
	_tmp4_ = uri;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = uri;
		_tmp3_ = g_strcmp0 (_tmp5_, "about:blank") == 0;
	}
	if (_tmp3_) {
		gtk_entry_set_text ((GtkEntry*) self, "");
	} else {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = gtk_entry_get_text ((GtkEntry*) self);
		_tmp7_ = _tmp6_;
		if (g_strcmp0 (_tmp7_, "") == 0) {
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp8_ = uri;
			_tmp9_ = webkit_uri_for_display (_tmp8_);
			_tmp10_ = _tmp9_;
			gtk_entry_set_text ((GtkEntry*) self, _tmp10_);
			_g_free0 (_tmp10_);
		}
	}
	ephemeral_url_entry_set_secondary_icon (self);
	result = FALSE;
	_g_free0 (uri);
	return result;
}

static gboolean
__ephemeral_url_entry___lambda22__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                              GdkEventFocus* event,
                                                              gpointer self)
{
	gboolean result;
	result = _ephemeral_url_entry___lambda22_ ((EphemeralUrlEntry*) self, event);
	return result;
}

static void
_ephemeral_url_entry___lambda23_ (EphemeralUrlEntry* self,
                                  GtkEntryIconPosition icon_pos,
                                  GdkEventButton* event)
{
	g_return_if_fail (event != NULL);
	if (icon_pos == GTK_ENTRY_ICON_PRIMARY) {
		gtk_widget_grab_focus ((GtkWidget*) self);
	} else {
		if (icon_pos == GTK_ENTRY_ICON_SECONDARY) {
			gboolean _tmp0_;
			gboolean _tmp1_;
			g_object_get ((GtkWidget*) self, "has-focus", &_tmp0_, NULL);
			_tmp1_ = _tmp0_;
			if (_tmp1_) {
				g_signal_emit_by_name ((GtkEntry*) self, "activate");
			} else {
				EphemeralWebView* _tmp2_;
				const gchar* _tmp3_;
				SoupURI* _tmp4_;
				SoupURI* _tmp5_;
				_tmp2_ = self->priv->_web_view;
				_tmp3_ = webkit_web_view_get_uri ((WebKitWebView*) _tmp2_);
				_tmp4_ = soup_uri_new (_tmp3_);
				_tmp5_ = _tmp4_;
				ephemeral_url_entry_toggle_suggestion (self, _tmp5_);
				__vala_SoupURI_free0 (_tmp5_);
			}
		}
	}
}

static void
__ephemeral_url_entry___lambda23__gtk_entry_icon_release (GtkEntry* _sender,
                                                          GtkEntryIconPosition icon_pos,
                                                          GdkEventButton* event,
                                                          gpointer self)
{
	_ephemeral_url_entry___lambda23_ ((EphemeralUrlEntry*) self, icon_pos, event);
}

static void
_ephemeral_url_entry___lambda24_ (Block14Data* _data14_,
                                  WebKitWebView* source,
                                  WebKitLoadEvent e)
{
	EphemeralUrlEntry* self;
	gchar* uri = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data14_->self;
	g_return_if_fail (source != NULL);
	_tmp0_ = webkit_web_view_get_uri (source);
	_tmp1_ = g_strdup (_tmp0_);
	uri = _tmp1_;
	g_signal_handler_block (self, _data14_->changed_event);
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = uri;
		_tmp5_ = webkit_uri_for_display (_tmp4_);
		_tmp6_ = _tmp5_;
		gtk_entry_set_text ((GtkEntry*) self, _tmp6_);
		_g_free0 (_tmp6_);
		ephemeral_url_entry_set_secondary_icon (self);
	}
	g_signal_handler_unblock (self, _data14_->changed_event);
	_g_free0 (uri);
}

static void
__ephemeral_url_entry___lambda24__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                                WebKitLoadEvent load_event,
                                                                gpointer self)
{
	_ephemeral_url_entry___lambda24_ (self, _sender, load_event);
}

static GObject *
ephemeral_url_entry_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	EphemeralUrlEntry * self;
	Block14Data* _data14_;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** initial_favorites = NULL;
	GSettings* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint initial_favorites_length1;
	gint _initial_favorites_size_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gulong _tmp21_;
	EphemeralWebView* _tmp22_;
	parent_class = G_OBJECT_CLASS (ephemeral_url_entry_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntry);
	_data14_ = g_slice_new0 (Block14Data);
	_data14_->_ref_count_ = 1;
	_data14_->self = g_object_ref (self);
	_tmp0_ = g_strdup (_ ("Enter a URL or search term"));
	_data14_->tooltip_text = _tmp0_;
	_tmp1_ = _data14_->tooltip_text;
	gtk_entry_set_placeholder_text ((GtkEntry*) self, _tmp1_);
	ephemeral_url_entry_set_last_text (self, "");
	_tmp2_ = g_strdup ("<Ctrl>l");
	_tmp3_ = g_new0 (gchar*, 1 + 1);
	_tmp3_[0] = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = 1;
	_tmp5_ = _data14_->tooltip_text;
	_tmp6_ = granite_markup_accel_tooltip (_tmp4_, (gint) 1, _tmp5_);
	_tmp7_ = _tmp6_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) self, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
	g_object_set ((GtkEntry*) self, "primary-icon-name", "system-search-symbolic", NULL);
	_tmp8_ = _data14_->tooltip_text;
	g_object_set ((GtkEntry*) self, "primary-icon-tooltip-text", _tmp8_, NULL);
	_tmp9_ = g_strdup ("<Ctrl>l");
	_tmp10_ = g_new0 (gchar*, 1 + 1);
	_tmp10_[0] = _tmp9_;
	_tmp11_ = _tmp10_;
	_tmp11__length1 = 1;
	g_object_get ((GtkEntry*) self, "primary-icon-tooltip-text", &_tmp12_, NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = _tmp13_;
	_tmp15_ = granite_markup_accel_tooltip (_tmp11_, (gint) 1, _tmp14_);
	_tmp16_ = _tmp15_;
	g_object_set ((GtkEntry*) self, "primary-icon-tooltip-markup", _tmp16_, NULL);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
	_tmp17_ = ephemeral_application_settings;
	_tmp19_ = _tmp18_ = g_settings_get_strv (_tmp17_, "favorite-websites");
	initial_favorites = _tmp19_;
	initial_favorites_length1 = _vala_array_length (_tmp18_);
	_initial_favorites_size_ = initial_favorites_length1;
	_tmp20_ = initial_favorites;
	_tmp20__length1 = initial_favorites_length1;
	ephemeral_url_entry_reload_suggestions (self, _tmp20_, (gint) _tmp20__length1);
	ephemeral_url_entry_set_secondary_icon (self);
	g_signal_connect_data ((GtkEditable*) self, "changed", (GCallback) __ephemeral_url_entry___lambda16__gtk_editable_changed, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
	_tmp21_ = g_signal_connect_object ((GtkEditable*) self, "changed", (GCallback) __ephemeral_url_entry___lambda17__gtk_editable_changed, self, 0);
	_data14_->changed_event = _tmp21_;
	g_signal_connect_object ((DzlSuggestionEntry*) self, "activate-suggestion", (GCallback) __ephemeral_url_entry___lambda18__dzl_suggestion_entry_activate_suggestion, self, 0);
	g_signal_connect_object ((DzlSuggestionEntry*) self, "suggestion-activated", (GCallback) __ephemeral_url_entry___lambda19__dzl_suggestion_entry_suggestion_activated, self, 0);
	g_signal_connect_data ((DzlSuggestionEntry*) self, "move-suggestion", (GCallback) __ephemeral_url_entry___lambda20__dzl_suggestion_entry_move_suggestion, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
	g_signal_connect_object ((GtkWidget*) self, "focus-in-event", (GCallback) __ephemeral_url_entry___lambda21__gtk_widget_focus_in_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) __ephemeral_url_entry___lambda22__gtk_widget_focus_out_event, self, 0);
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) __ephemeral_url_entry___lambda23__gtk_entry_icon_release, self, 0);
	_tmp22_ = self->priv->_web_view;
	g_signal_connect_data ((WebKitWebView*) _tmp22_, "load-changed", (GCallback) __ephemeral_url_entry___lambda24__webkit_web_view_load_changed, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
	initial_favorites = (_vala_array_free (initial_favorites, initial_favorites_length1, (GDestroyNotify) g_free), NULL);
	return obj;
}

static void
ephemeral_url_entry_class_init (EphemeralUrlEntryClass * klass,
                                gpointer klass_data)
{
	ephemeral_url_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &EphemeralUrlEntry_private_offset);
	((GtkEntryClass *) klass)->populate_popup = (void (*) (GtkEntry*, GtkMenu*)) ephemeral_url_entry_real_populate_popup;
	G_OBJECT_CLASS (klass)->get_property = _vala_ephemeral_url_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_ephemeral_url_entry_set_property;
	G_OBJECT_CLASS (klass)->constructor = ephemeral_url_entry_constructor;
	G_OBJECT_CLASS (klass)->finalize = ephemeral_url_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), EPHEMERAL_URL_ENTRY_WEB_VIEW_PROPERTY, ephemeral_url_entry_properties[EPHEMERAL_URL_ENTRY_WEB_VIEW_PROPERTY] = g_param_spec_object ("web-view", "web-view", "web-view", EPHEMERAL_TYPE_WEB_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
ephemeral_url_entry_instance_init (EphemeralUrlEntry * self,
                                   gpointer klass)
{
	self->priv = ephemeral_url_entry_get_instance_private (self);
}

static void
ephemeral_url_entry_finalize (GObject * obj)
{
	EphemeralUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntry);
	_g_object_unref0 (self->priv->_list_store);
	_g_free0 (self->priv->_last_text);
	_g_object_unref0 (self->priv->_web_view);
	G_OBJECT_CLASS (ephemeral_url_entry_parent_class)->finalize (obj);
}

GType
ephemeral_url_entry_get_type (void)
{
	static volatile gsize ephemeral_url_entry_type_id__volatile = 0;
	if (g_once_init_enter (&ephemeral_url_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EphemeralUrlEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ephemeral_url_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EphemeralUrlEntry), 0, (GInstanceInitFunc) ephemeral_url_entry_instance_init, NULL };
		GType ephemeral_url_entry_type_id;
		ephemeral_url_entry_type_id = g_type_register_static (dzl_suggestion_entry_get_type (), "EphemeralUrlEntry", &g_define_type_info, 0);
		EphemeralUrlEntry_private_offset = g_type_add_instance_private (ephemeral_url_entry_type_id, sizeof (EphemeralUrlEntryPrivate));
		g_once_init_leave (&ephemeral_url_entry_type_id__volatile, ephemeral_url_entry_type_id);
	}
	return ephemeral_url_entry_type_id__volatile;
}

static void
_vala_ephemeral_url_entry_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	EphemeralUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntry);
	switch (property_id) {
		case EPHEMERAL_URL_ENTRY_WEB_VIEW_PROPERTY:
		g_value_set_object (value, ephemeral_url_entry_get_web_view (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_ephemeral_url_entry_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	EphemeralUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, EPHEMERAL_TYPE_URL_ENTRY, EphemeralUrlEntry);
	switch (property_id) {
		case EPHEMERAL_URL_ENTRY_WEB_VIEW_PROPERTY:
		ephemeral_url_entry_set_web_view (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

